#!perl

use ExtUtils::MakeMaker;
use Apache::src ();
use Config;

use strict;

my %config;

my $src = Apache::src->new;

$config{INC} = $src->inc;
$config{TYPEMAPS} = $src->typemaps;

if ($^O =~ /Win32/) {
  require Apache::MyConfig;

  $config{DEFINE}  = ' -D_WINSOCK2API_ -D_MSWSOCK_ ';
  $config{DEFINE} .= ' -D_INC_SIGNAL -D_INC_MALLOC '
    if $Config{usemultiplicity};

  $config{LIBS} =
    qq{ -L"$Apache::MyConfig::Setup{APACHE_LIB}" -lApacheCore } .
    qq{ -L"$Apache::MyConfig::Setup{MODPERL_LIB}" -lmod_perl};
}

WriteMakefile(
  NAME         => 'Apache::ConnectionCleanup::RegisterCleanup',
  VERSION_FROM => 'RegisterCleanup.pm',
  PREREQ_PM    => { mod_perl => 1.26 },
  ABSTRACT     => 'An XS-based Apache module',
  AUTHOR       => 'geoff@cpan.org',
  %config,
);

