#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "mod_perl.h"

typedef struct {
    request_rec *r;
    SV *cv;
    int refcnt;
} conn_cleanup_t;

static void conn_cleanup_handler(void *data)
{
    conn_cleanup_t *conn = (conn_cleanup_t*)data;
    (void)acquire_mutex(mod_perl_mutex);
    perl_call_handler(conn->cv, conn->r, Nullav);
    if(conn->refcnt) SvREFCNT_dec(conn->cv);
    (void)release_mutex(mod_perl_mutex);
}

static void ApacheConnection_register_cleanup(conn_rec *c, SV *cv)
{
    pool *p = c->pool;
    server_rec *s = c->server;
    conn_cleanup_t *conn = (conn_cleanup_t *)palloc(p,sizeof(conn_cleanup_t));

    conn->r = mp_fake_request_rec(s, p, "Apache::ConnectionCleanup::RegisterCleanup::register_cleanup\n");
    conn->cv = cv;
    if(SvREFCNT(conn->cv) == 1) {
        conn->refcnt = 1;
        SvREFCNT_inc(conn->cv);
    }
    else
        conn->refcnt = 0;
    register_cleanup(p, conn, conn_cleanup_handler, mod_perl_noop);
}

MODULE = Apache::ConnectionCleanup::RegisterCleanup          PACKAGE = Apache::ConnectionCleanup::RegisterCleanup

PROTOTYPES: DISABLE

void
register_cleanup(conn, cv)
    Apache::Connection conn
    SV *cv

    CODE:
      ApacheConnection_register_cleanup(conn, cv);

