use strict;
use warnings FATAL => 'all';

use Apache::Test;
use Apache::TestRequest;

use File::Spec;

Apache::TestRequest::user_agent(keep_alive => 1);

plan tests => 19, have_lwp;

my $tmpfile = File::Spec->catfile(File::Spec->tmpdir, 'single');

my $response = GET '/single/index.html';
ok $response->code == 200;
ok $response->content;
ok(! -f $tmpfile);

$response = GET '/single/index.html';
ok $response->code == 200;
ok $response->content;
ok(! -f $tmpfile);

$response = GET '/single/index.html';
ok $response->code == 200;
ok $response->content;
ok(! -f $tmpfile);

$response = GET '/single/index.html', Connection => 'close';
ok $response->code == 200;
ok $response->content;
ok(-f $tmpfile);
my $size = (stat $tmpfile)[7];
ok ($size == 1);

$response = GET '/single-retest/index.html';
ok $response->code == 200;
$size = (stat $tmpfile)[7];
ok ($size == 1);

$response = GET '/single-retest/index.html';
ok $response->code == 200;
$size = (stat $tmpfile)[7];
ok ($size == 1);

$response = GET '/single-retest/index.html', Connection => 'close';
ok $response->code == 200;
$size = (stat $tmpfile)[7];
ok ($size == 2);

