package My::Single;

use Apache::Constants qw(OK);
use Apache::ConnectionCleanup;
use File::Spec;
use IO::File;
use strict;

$My::Single::Run = 0;

sub handler {

  my $r = Apache::ConnectionCleanup->new(shift);

  # increment the counter for each request
  $My::Single::Run++;

  # and create a closure to reset the counter after the first run
  my $marker = bless {}, 'My::Single';

  $r->connection->register_cleanup(sub { single($marker) } );

  return OK;

}

sub single {

  # only run if we're allowed
  return unless $My::Single::Run;

  my $tmpfile = File::Spec->catfile(File::Spec->tmpdir, 'single');

  my $fh = IO::File->new(">>$tmpfile") or die;

  $fh->autoflush(1);

  print $fh '1';

  undef $fh;
}

sub DESTROY {
  # after the first closure is complete, reset the 
  # counter to make sure we only run once
  $My::Single::Run = 0;
}
1;
